Listing 8.46. Kompletna procedura odczytu zawartoci pamici ukadu DS1990A
;********************************
;procedura odczytania zawartoci
;pamici ROM DS1990A. Odczytane
;bajty w pamici RAM od adresu
;20h. Jeeli CRC OK to bit
; crc_ok=1
;********************************
_czytaj_DS	call res_ds			;impuls inicjalizacji
				btfsc presen
				goto et_odb_DS1
				movlw.250
				;odczekanie 0,5 s
				call delay_msek
				movlw.250
				call delay_msek
				goto _czytaj_DS	
				;czekaj na impuls
				;presence

et_odb_DS1	movlw 33h
				;kod odczytu pamici ROM
				call wr_ds
	
				movlw 20h
				movwf fsr				;pocztek bufora RAM
				clrf CRC				;warto pocztkowa CRC
				movlw.8				;licznik odbieranych bajtw
				movwf licznik1

et_odb_DS	call rd_ds			;odczytanie bajtu z DS1990A
				movwf indf			;zapisywanie do bufora RAM
				incf fsr,f
				call wyl_CRC			;wyliczanie CRC
				decfsz licznik1,f
				goto et_odb_DS

				bcf crc_ok			;crc_ok=0
				movf CRC,w
				btfsc Z
				bsf crc_ok			;crc_ok=1, gdy CRC=0
				return
