Przykad 5.2. Sposb wykrycia rda sygnau przerwania
;zapamitanie wartoci rejestrw W i STATUS (z przykadu 5.1)
	MOVWF W_TEMP
	SWAPF STATUS,W
	MOVWF STATUS_TEMP

; pocztek waciwej procedury obsugi przerwania
	CLRF STATUS 				; wybierz bank 0
	BTFSC INTCON,T0IF		; przerwanie od TIMER0?
	GOTO T0_INT 				; tak - skok do procedury obsugi 
								; przerwania TIMER0
	BTFSC INTCON,INTF 		; przerwanie zewntrzne INT
	GOTO INT_INT			; tak - skok do procedury obsugi przerwania INT
	BTFSC INTCON,RBIF		; przerwanie od zmian na liniach PORTB?
	GOTO PORTB_INT			; tak - skok do procedury obsugi przerwania RB
	BSF STATUS,RP0			; wybierz bank 1 (bo rejestr EECON1 znajduje
								; si w banku 1)
	BTFSC EECON1,EEIF 		; przerwanie po zakoczeniu zapisywania pamici
								; EEPROM?
	GOTO EEPROM_INT		; tak - skok do procedury obsugi przerwania EE

	INT_ERR	GOTO INT_ERR	; puapka na wypadek kiedy przerwanie 
								; przyjto, a nie wykryto rda
		....

; obsuga przerwania TIMER0
T0_INT
	...
	BCF INTCON,T0IF		; zerowanie znacznika zgoszenia przerwania
	GOTO END
	...

; obsuga przerwania INT
INT_INT
	...
	BCF INTCON.INTF		; zerowanie znacznika zgoszenia przerwania
	GOTO END

; obsuga przerwania po zakoczeniu zapisywania pamici EEPROM
EEPROM_INT
	...
	BCF EECON1,EEIF		; zerowanie znacznika zgoszenia przerwania
	GOTO END

; obsuga przerwania po zmianie stanu na liniach RB7...RB4
PORTB_INT
	...
	BCF INTCON,RBIF		; zerowanie znacznika zgoszenia przerwania

END					; odtworzenie rejestrw W i STATUS (z przykadu 5.1)
	SWAPF STATUS_TEMP,W
	MOVWF STATUS
	SWAPF W_TEMP,F 
	SWAPF W_TEMP,W
	RETFIE
